# -*- coding: utf-8 -*-

"""
/***************************************************************************
 ForstProcessing
                                 A QGIS plugin
 ForstProcessing
 Generated by Plugin Builder: http://g-sherman.github.io/Qgis-Plugin-Builder/
                              -------------------
        begin                : 2018-11-13
        copyright            : (C) 2018 by CHL
        email                : christina_ludwig@gmx.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
"""

__author__ = 'CHL'
__date__ = '2018-11-13'
__copyright__ = '(C) 2018 by CHL'

# This will get replaced with a git SHA1 when you do a git archive

__revision__ = '$Format:%H$'

from qgis.core import QgsProcessingProvider
from ._1_new_shapefile_template.new_shapefile_template import NewShapefileTemplate
from ._2_calculate_geometry.calculate_geometry import CalculateGeometry
from ._3_generate_cruisepoints.generate_cruisepoints import GenerateCruisePoints
from ._4_add_traverse_points.add_traverse_points import AddTraversePoints
from ._5_hyperlink.hyperlink import Hyperlink
from ._6_address_lookup.address_lookup import AddressLookup
from ._7_reset.reset_settings import ResetForstSettings

from qgis.PyQt.QtGui import QIcon
from .resources import *

class ForstProcessingProvider(QgsProcessingProvider):


    def __init__(self):
        QgsProcessingProvider.__init__(self)

    def unload(self):
        """
        Unloads the provider. Any tear-down steps required by the provider
        should be implemented here.
        """
        pass

    def loadAlgorithms(self):
        """
        Loads all algorithms belonging to this provider.
        """
        self.addAlgorithm(NewShapefileTemplate())
        self.addAlgorithm(CalculateGeometry())
        self.addAlgorithm(Hyperlink())
        self.addAlgorithm(AddressLookup())
        self.addAlgorithm(GenerateCruisePoints())
        self.addAlgorithm(AddTraversePoints())
        self.addAlgorithm(ResetForstSettings())


    def id(self):
        """
        Returns the unique provider id, used for identifying the provider. This
        string should be a unique, short, character only string, eg "qgis" or
        "gdal". This string should not be localised.
        """
        return 'ForstvereinSteiermark'

    def name(self):
        """
        Returns the provider name, which is used to describe the provider
        within the GUI.

        This string should be short (e.g. "Lastools") and localised.
        """
        return self.tr('Forstverein Steiermark')

    def longName(self):
        """
        Returns the a longer version of the provider name, which can include
        extra details such as version numbers. E.g. "Lastools LIDAR tools
        (version 2.2.1)". This string should be localised. The default
        implementation returns the same string as name().
        """
        return self.name()

    def icon(self):
        return QIcon(":/plugins/icons/forstverein.jpg")
